
import java.util.Random;

public class Cassini  {
  
  private static final int LKM = 8;
  private int[] x = new int[LKM];
  private int[] y = new int[LKM];
  private int[] dx = new int[LKM];
  private int[] dy = new int[LKM];
    

  private int h,w;
    
  private Random random;
  

  public Cassini(int width, int height) {
    w = width;
    h = height;
    random = new Random(0xdeadbeef);

    init();
  }
  

  
  private void init() {
    for (int i = 0; i < LKM; i++) {
      x[i] = random.nextInt(w);
      y[i] = random.nextInt(h);
      dx[i] = random.nextInt(13)-6;
      dy[i] = random.nextInt(13)-6;
    }
  }

  public void render(int[] screen) {
    for (int i = 0; i < LKM; i++) {
      x[i] += dx[i];
      if (x[i] < 0) {
        x[i] = -x[i];
        dx[i] = -dx[i];
      }
      else if (x[i] >= w) {
        x[i] = (w<<1)-x[i]-1;
        dx[i] = -dx[i];
      }
      y[i] += dy[i];
      if (y[i] < 0) {
        y[i] = -y[i];
        dy[i] = -dy[i];
      }
      else if (y[i] >= h) {
        y[i] = (h<<1)-y[i]-1;
        dy[i] = -dy[i];
      }
    }
    
    int max = w*h;
    int offs = 0;
    for (int iy = 0; iy < h; iy++) {
      for (int ix = 0; ix < w; ix++) {
        double r = 1;
        for (int i = 0; i < LKM; i++) {
          int dx = ix-x[i];
          int dy = iy-y[i];
          r *= dx*dx+dy*dy;
        }
        r = Math.pow(r, (0.5/LKM));
        int d = (int)r;

        screen[offs++] = 0xff000000 | d<<18 | d << 9;
      }
    }    
  }
}
