
import java.util.Random;

public class Fire {
    
 
  private Random r;
    
  

  private static final int FIRES = 5000;
  private static final int MAXLIFE = 80;

  private float[] fireX    = new float[FIRES];
  private float[] fireY    = new float[FIRES];
  private float[] fireSpeedX = new float[FIRES];
  private float[] fireSpeedY = new float[FIRES];
  private int[] fireLife  = new int[FIRES];
  
  private int[] colors = new int[256];

  private int w;
  private int h;

  private int softness = 2; //parillinen
  private int [] soft;


  private int fx=100;
  private int fy =100;
  private int fdx = 3;
  private int fdy = 3;

  public Fire(int width, int height, int[] buffer) {

    w = width;
    h = height;
    r = new Random(0xBEEFCA5E);
  
    soft = buffer;
    for (int i = 0; i < soft.length; i++)
      soft[i] = 0;

    initFires();
    initColors();
  }

 
  private void soften(int[] screen) {
    
    int sum;
    int w2 = w-2;
    int h1 = h-1;
    int w1 = w-1;
    for (int s = 0; s < softness; s++) {
      for (int j = 1 ; j < h1; j++) {
	int row = j*w;
        for (int i = 1 ; i < w1; i++) {
	  sum = 0;
          int r = row-w+i-1;
	  sum += screen[r++];
	  sum += screen[r++];
          sum += screen[r];
          r += w2;
          sum += screen[r++];
	  sum += screen[r++]; 
          sum += screen[r];
          r += w2;
          sum += screen[r++];
          sum += screen[r++];
          sum += screen[r];
	  
	  soft[row+i] = sum/9;
	}
      }
      
      int [] tmp = screen;
      screen = soft;
      soft = tmp;
      /*
      int n = screen.length;
      for (int i = 0; i < n; i++)
        screen[i] = soft[i];
      */
    }
  }

  private void initColors() {
    int r = 255;
    int g = 0;
    int b = 0;
    
    for (int i = 0; i < 32; i++) {
      colors[i] = 0xff000000 | (i<<16) | (i<<8) | i;
    }
    // musta -> punainen
    for (int i = 32; i < 128; i++) {
      int rr = 32+((int)(( (i-32) * (r-32) )/96.0))<<16;
      int gg = 32+((int)(( (i-32) * (-32) )/96.0))<<8;
      int bb = 32+((int)(( (i-32) * (-32) )/96.0));
      colors[i] = 0xff000000 | rr | gg | bb ;
    }    

    int g2 = 255;
    int b2 = 0;
    // punainen -> keltainen
    for (int i = 128; i < 192; i++) {
      int green = g + (int)(( (i-128) * ( g2-g))/64.0);
      int blue = b + (int)(( (i-128) * ( b2-b))/64.0);
      colors[i] = 0xff000000 |(255 <<16)|(green<<8)|blue; 
    }

    b = 255;
    // keltainen -> valkoinen
    for (int i = 192; i < 256; i++) {
      int blue = b2 + (int)(( (i-192) * ( b-b2))/64.0);
      colors[i] = 0xff000000 |(255 <<16)|(255<<8)|blue; 
    }
  }
  
  private void initFires() {
    int x = ( w * ( h >> 1 )) + (w >> 1);    
    for (int i = 0 ; i < FIRES; i++) {
      fireX[i] = x + r.nextInt(50) - 25;
      fireY[i] = h>>1;
      fireLife[i] = r.nextInt(MAXLIFE);
    }
    
  }
  
  public final void render(int [] screen) {
    int n = w*h;
    fx+=fdx;
    fy+=fdy;
    if (fx > w) {
      fx = 2*w-fx;
      fdx = -fdx;
    }
    else if (fx < 0) {
      fx = -fx;
      fdx = -fdx;
    }
    if (fy > h) {
      fy = 2*h-fy;
      fdy = -fdy;
    }
    else if (fy < 0) {
      fy = -fy;
      fdy = -fdy;
    }
    for (int i = 0; i < n; i++) 
      screen[i] = 0;
    
    int maxvalue = 10;
    int [] mask = {
      9,7,4,7,9,
      7,5,2,5,7,
      4,2,0,2,4,
      7,5,2,5,7,
      9,7,4,7,9
    };

    for (int i = 0; i < FIRES; i++) {
      int x = (int) fireX[i];
      int y = (int) fireY[i];
      if (x < 2 || x >= w -2 || y < 2 || y >=h-2)
        continue;
      int m = 0;
      for (int r = -2; r < 3; r++) {
        for (int c = -2; c < 3; c++) {
          screen[(y+r)*w+c+x] += maxvalue-mask[m++];
        }
      }
    }
    
    
    for (int i = 0; i < FIRES; i++) {
      if (fireLife[i] <= 0) {
	fireLife[i] = r.nextInt(MAXLIFE);
	fireSpeedX[i] = r.nextFloat()*3-1;
        fireSpeedY[i] = -r.nextFloat()*3;
        int ra = r.nextInt(30);
        double ang = r.nextFloat()*2*Math.PI;
	fireX[i] = fx + (int)(ra*Math.cos(ang));
        fireY[i] = fy + (int)(ra*Math.sin(ang));
      }
      else {
	int x = ((int)fireX[i])+(w*((int)fireY[i]));
	if (x < 0) {
          fireLife[i]-=3;
          continue;
        }
        else if (x >= w*h) {
          fireLife[i]-=3;
          continue;
        }
	int I = screen[x];
	if (I < 80)
          fireLife[i]--;

	fireLife[i]--;
        fireX[i] += fireSpeedX[i];
        fireY[i] += fireSpeedY[i];
        
      }
    }
    
    soften(screen);
    
    for (int i = 0; i < n; i++) {
      int I = screen[i]<< 1;
      screen[i] = (I >= 256) ? 0xffffffff : colors[I];
    }
  }
}
