import java.util.Random;

public class Noise {
  
  private int[] buffer2;
  private int[] buffer3;

  private int h,w;
  private static final int addition = 3;
  
  private Random random;
  
  public Noise(int width, int height) {
    w = width;
    h = height;
    
    buffer2=new int[w*h];
    buffer3=new int[w*h];
    
    random = new Random(0xF00BA7BADDEAL);
  }
 
  public void init(long seed) {
    random.setSeed(seed);
  }


  private void noiseup(int[] buffer) {
    int max = w*h;
    for (int i = 0; i < max; i++)
      buffer[i] = 128;

    double d = Math.sqrt(w*w + h*h);
  
    for (int n = 0; n < 250; n++) {
      double v = random.nextFloat()*2*Math.PI;
      double a = Math.sin(v);
      double b = Math.cos(v);
      double c = random.nextFloat()*d - d/2;
      
      v = random.nextFloat()*2*Math.PI;
      double a2 = Math.sin(v);
      double b2 = Math.cos(v);
      double c2 = random.nextFloat()*d - d/2;
      
      
      int ib = (int)(-4096*b/a);
      int ic = (int)(4096*c/a);
      int ib2 = (int)(-4096*b2/a2);
      int ic2 = (int)(4096*c2/a2);
      
      int ia = a < 0? -1:1;
      int ia2 = a2 < 0? -1:1;
      ic -=ib;
      ic2-=ib2;
    
      int offs = 0;
      
      for (int j = 0; j < h; j++) {
        int x  = (ic += ib)>>12;
        int x2 = (ic2 += ib2)>>12;        
        if (x > w)
          x = w;
        else if (x < 0)
          x = 0;
        if (x2 > w)
          x2 = w;
        else if (x2 < 0)
          x2 = 0;
                
        if (ia < 0) {
          if(ia2 < 0) {
            if (x < x2) {
              int i;
              for (i = 0; i < x; i++)
                buffer[offs++] += 2*addition;
              offs+=x2-x;
              for (i = x2 ; i < w; i++)
                buffer[offs++] -= 2*addition;
            }
            else {
              int i;
              for (i = 0; i < x2; i++)
                buffer[offs++] += 2*addition;
              offs+=x-x2;
              for (i = x ; i < w; i++)
                buffer[offs++] -= 2*addition;
            }
          }
          else {
             if (x < x2) {
              int i;
              offs+=x;
              for (i = x; i < x2; i++)
                buffer[offs++] -= 2*addition;
              offs+=w-x2;
             }
             else {
              int i;
              offs+=x2;
              for (i = x2; i < x; i++)
                buffer[offs++] += 2*addition;
              offs+=w-x;
             }
             
          }
        }
        else {
          if(ia2 > 0) {
            if (x < x2) {
              int i;
              for (i = 0; i < x; i++)
                buffer[offs++] -= 2*addition;
              offs+=x2-x;
              for (i = x2 ; i < w; i++)
                buffer[offs++] += 2*addition;
            }
            else {
              int i;
              for (i = 0; i < x2; i++)
                buffer[offs++] -= 2*addition;
              offs+=x-x2;
              for (i = x; i < w; i++)
                buffer[offs++] += 2*addition;
            }
          }
          else {
            if (x < x2) {
              int i;
              offs+=x;
              for (i = x; i < x2; i++)
                buffer[offs++] += 2*addition;
              offs+=w-x2;
            }
            else {
              int i;
              offs+=x2;
              for (i = x2; i < x; i++)
                buffer[offs++] -= 2*addition;
              offs+=w-x;
            }
            
          }
        }
      }
    }
  }
   
 public boolean render(int [] target) {

    noiseup(target);
    noiseup(buffer2);
    noiseup(buffer3);
    
    int max = target.length;

    for (int i = 0; i < max; i++) {
      int blue = target[i];
      if (blue < 0) blue = 0;
      else if (blue > 255 ) blue = 255;
      int green = buffer2[i];
      if (green < 0) green = 0;
      else if (green > 255 ) green = 255;
      int red = buffer3[i];
      if (red < 0) red = 0;
      else if (red > 255 ) red = 255;
      
      target[ i ] = (0xff000000 | (red<<16) | (green<<8) | blue);
    }
    return true;
  }
  
  
}
