import java.awt.*;
import java.awt.image.*;

public class Scroller {
  private int[] text;
  private int[] colors = new int[256];
  
  private int w, h;
  
  public Scroller(int width, int height, int [] buffer) {

    w = 320;
    h = 200;
    text = buffer;
    getText();    
    initColors();
  }

  private void getText() {
    for (int i = 0; i < w*h; i++)
      text[i] = 0;

    BufferedImage image = new BufferedImage(w, h, BufferedImage.TYPE_INT_ARGB);
    Graphics2D g = image.createGraphics();
    g.setColor(new Color(255,255,255));
    g.setFont(new Font("Serif", Font.BOLD, 18));
    FontMetrics fm = g.getFontMetrics();
    int fh = fm.getHeight();
    String [] texts = {"Hyv uutta vuotta","2005","","",
                      "Toteutus:","Jorma Sainio","jsainio@jippii.fi"};  
    int mid = w>>1;

    for (int i = 0; i < texts.length; i++) {
      String s = texts[i];
      g.drawString(s, mid-fm.stringWidth(s)/2, 20+fh*i);
    }
    image.getRGB(0,0,w,h, text, 0, w );

  }

  private static final double sq(double d) { return d*d;};

  private void initColors() {
    
    colors[0] = 0xff000000;
    
    for (int i = 1; i < 256; i++) {
      int r = 0xff & (int)(255*sq(Math.sin((i<<4)*Math.PI/256)));
      int g = 0xff & (int)(255*sq(Math.sin((i<<3)*Math.PI/256+1.212)));
      int b = 0xff & (int)(255*sq(Math.sin((i<<2)*Math.PI/256+0.234)));
      colors[i] = 0xff000000 | (r << 16) | (g << 8) | b;
      
    }
  }

  public void rotateColors() {
    
    int col = colors[0];
    for (int i = 0; i < 255; i++)
      colors[i] = colors[i+1];
    colors[255] = col;
    
  }
  
  private int foo = -200;
  public void render(int [] backgroud, int [] screen) {
    foo++;
    rotateColors();
    int n = w*h;
    for (int i = 0; i < n; i++)
      screen[i] = backgroud[i]; 

    int time = (int)System.currentTimeMillis();

    for (int y = 0; y < h; y++) {
      int d = (int)(30*Math.sin(2*y*2*Math.PI/h+time/1234.56));
      int fooy = (y+foo)%h;
      if (fooy < 0)
        continue;
      for (int x = 0; x < w; x++) {
        int tx = x+d;
        if (tx < 0 || tx >= w)
          continue;

        int b = text[fooy*w+tx];
        
        if ( b != 0)
          screen[y*w+x] = colors[ tx & 0xff ];
 
      }
    }
  }
}
